unit KeyUtils;

interface
function ShrLoEn(ds: char; var vs: byte): boolean;
function ShrLoRu(ds: char; var vs: byte): boolean;
function ShrHiEn(ds: char; var vs: byte): boolean;
function ShrHiRu(ds: char; var vs: byte): boolean;
function Num(ds: char; var vs: byte): boolean;
function Comm(ds: char; var vs, ks: byte; var vsf, ksf: boolean): boolean;
function RusToLat(text: string): string;
function ChrCnv(ds: byte; var vs, ks: char): boolean;
implementation

function ShrLoEn(ds: char; var vs: byte): boolean;
begin
Result:= true; case ds of
'q': vs:= 81; 'w': vs:= 87; 'e': vs:= 69; 'r': vs:= 82; 't': vs:= 84;
'y': vs:= 89; 'u': vs:= 85; 'i': vs:= 73; 'o': vs:= 79; 'p': vs:= 80;
'a': vs:= 65; 's': vs:= 83; 'd': vs:= 68; 'f': vs:= 70; 'g': vs:= 71;
'h': vs:= 72; 'j': vs:= 74; 'k': vs:= 75; 'l': vs:= 76; 'z': vs:= 90;
'x': vs:= 88; 'c': vs:= 67; 'v': vs:= 86; 'b': vs:= 66; 'n': vs:= 78;
'm': vs:= 77; else Result:= false; end;
end;

function ShrLoRu(ds: char; var vs: byte): boolean;
begin
Result:= true; case ds of
'': vs:=192; '': vs:= 81; '': vs:= 87; '': vs:= 69; '': vs:= 82;
'': vs:= 84; '': vs:= 89; '': vs:= 85; '': vs:= 73; '': vs:= 79;
'': vs:= 80; '': vs:=219; '': vs:=221; '': vs:= 65; '': vs:= 83;
'': vs:= 68; '': vs:= 70; '': vs:= 71; '': vs:= 72; '': vs:= 74;
'': vs:= 75; '': vs:= 76; '': vs:=186; '': vs:=222; '': vs:= 90;
'': vs:= 88; '': vs:= 67; '': vs:= 86; '': vs:= 66; '': vs:= 78;
'': vs:= 77; '': vs:=188; '': vs:=190; else Result:= false; end;
end;

function ShrHiEn(ds: char; var vs: byte): boolean;
begin
Result:= true; case ds of
'Q': vs:= 81; 'W': vs:= 87; 'E': vs:= 69; 'R': vs:= 82; 'T': vs:= 84;
'Y': vs:= 89; 'U': vs:= 85; 'I': vs:= 73; 'O': vs:= 79; 'P': vs:= 80;
'A': vs:= 65; 'S': vs:= 83; 'D': vs:= 68; 'F': vs:= 70; 'G': vs:= 71;
'H': vs:= 72; 'J': vs:= 74; 'K': vs:= 75; 'L': vs:= 76; 'Z': vs:= 90;
'X': vs:= 88; 'C': vs:= 67; 'V': vs:= 86; 'B': vs:= 66; 'N': vs:= 78;
'M': vs:= 77; else Result:=false; end;
end;

function ShrHiRu(ds:char;var vs:byte):boolean;
begin
Result:= true; case ds of
'': vs:=192; '': vs:= 81; '': vs:= 87; '': vs:= 69; '': vs:= 82;
'': vs:= 84; '': vs:= 89; '': vs:= 85; '': vs:= 73; '': vs:= 79;
'': vs:= 80; '': vs:=219; '': vs:=221; '': vs:= 65; '': vs:= 83;
'': vs:= 68; '': vs:= 70; '': vs:= 71; '': vs:= 72; '': vs:= 74;
'': vs:= 75; '': vs:= 76; '': vs:=186; '': vs:=222; '': vs:= 90;
'': vs:= 88; '': vs:= 67; '': vs:= 86; '': vs:= 66; '': vs:= 78;
'': vs:= 77; '': vs:=188; '': vs:=190; else Result:= false; end;
end;

function Num(ds:char;var vs:byte):boolean;
begin
Result:= true; case ds of
'1': vs:= 49; '2': vs:= 50; '3': vs:= 51; '4': vs:= 52; '5': vs:= 53;
'6': vs:= 54; '7': vs:= 55; '8': vs:= 56; '9': vs:= 57; '0': vs:= 48;
else Result:= false; end;
end;

function Comm(ds:char;var vs,ks:byte;var vsf,ksf:boolean):boolean;
begin
Result:= true; case ds of
//               En       EnShift     Ru       RuShift
      '`': begin vs:=192; vsf:=false; ks:=  0;             end;
      '-': begin vs:=189; vsf:=false; ks:=189; ksf:=false; end;
      '=': begin vs:=187; vsf:=false; ks:=187; ksf:=false; end;
      '[': begin vs:=219; vsf:=false; ks:=  0;             end;
      ']': begin vs:=221; vsf:=false; ks:=  0;             end;
      ';': begin vs:=186; vsf:=false; ks:= 52; ksf:= true; end;
char(222): begin vs:=222; vsf:=false; ks:=  0;             end;
      ',': begin vs:=188; vsf:=false; ks:=191; ksf:= true; end;
      '.': begin vs:=190; vsf:=false; ks:=191; ksf:=false; end;
      '/': begin vs:=191; vsf:=false; ks:=220; ksf:= true; end;
      '\': begin vs:=220; vsf:=false; ks:=220; ksf:=false; end;
      '~': begin vs:=192; vsf:= true; ks:=  0;             end;
      '!': begin vs:= 49; vsf:= true; ks:= 49; ksf:= true; end;
      '@': begin vs:= 50; vsf:= true; ks:=  0;             end;
      '#': begin vs:= 51; vsf:= true; ks:=  0;             end;
      '$': begin vs:= 52; vsf:= true; ks:=  0;             end;
      '%': begin vs:= 53; vsf:= true; ks:= 53; ksf:= true; end;
      '^': begin vs:= 54; vsf:= true; ks:=  0;             end;
      '&': begin vs:= 55; vsf:= true; ks:=  0;             end;
      '*': begin vs:= 56; vsf:= true; ks:= 56; ksf:= true; end;
      '(': begin vs:= 57; vsf:= true; ks:= 57; ksf:= true; end;
      ')': begin vs:= 48; vsf:= true; ks:= 48; ksf:= true; end;
      '_': begin vs:=189; vsf:= true; ks:=189; ksf:= true; end;
      '+': begin vs:=187; vsf:= true; ks:=187; ksf:= true; end;
      '{': begin vs:=219; vsf:= true; ks:=  0;             end;
      '}': begin vs:=221; vsf:= true; ks:=  0;             end;
      ':': begin vs:=186; vsf:= true; ks:= 54; ksf:= true; end;
      '"': begin vs:=222; vsf:= true; ks:= 50; ksf:= true; end;
      '<': begin vs:=188; vsf:= true; ks:=  0;             end;
      '>': begin vs:=190; vsf:= true; ks:=  0;             end;
      '?': begin vs:=191; vsf:= true; ks:= 55; ksf:= true; end;
      '|': begin vs:=220; vsf:= true; ks:=  0;             end;
  {   '': begin vs:=  0;             ks:= 51; ksf:= true; end; }
            else Result:= false; end;
end;

function RusToLat(text : string) : string;
var ds, st : string; b : integer; stb : boolean;
begin
b:=1; stb:=false; while b <= length(text) do begin case text[b] of '': ds:='a';
'': ds:='b'; '': ds:='v'; '': ds:='g'; '': ds:='d'; '', '': begin ds:='e';
if stb then ds:= 'ye'; if length(st) > 0 then case st[length(st)] of
'a','e','o','y','u','i':ds:='ye';end else ds:='ye';end;'':ds:='zh';'':ds:='z';
'':ds:='i'; '':ds:='j'; '':ds:='k'; '': ds:='l'; '': ds:='m'; '': ds:='n';
'':ds:='o'; '':ds:='p'; '':ds:='r'; '': ds:='s'; '': ds:='t'; '': ds:='u';
'':ds:='f';'':ds:='h';'':ds:='ts';'':ds:='ch'; '':ds:='sh'; '':ds:='shch';
'', '': ds:= chr(39); '': ds:='y'; '': ds:='e'; '':ds:='yu'; '': ds:='ya';
'': ds:='A'; '': ds:='B'; '': ds:='V'; '': ds:='G'; '': ds:='D';
'', '': begin ds := 'E'; if stb then ds:= 'YE'; if length(st) > 0 then
case st[length(st)] of 'A','E','O','Y','U','I':ds:='YE'; end else ds:='YE'; end;
'':ds:='ZH'; '':ds:='Z'; '':ds:='I'; '':ds:='J'; '': ds:='K'; '': ds:='L';
'':ds:= 'M'; '':ds:='N'; '':ds:='O'; '': ds:='P';'': ds:='R'; '': ds:='S';
'':ds:= 'T'; '':ds:='U'; '':ds:='F'; '': ds:='H';'':ds:='TS'; '':ds:='CH';
'': ds:='SH'; '': ds:='SHCH'; '', '': ds:= '`'; '': ds:= 'Y'; '': ds:='E';
'': ds:='YU'; '': ds:='YA'; else ds:= text[b]; end; stb:= false; st:= st + ds;
if text[b]=' ' then begin st:=''; stb:= true;end;inc(b); Result:=Result+ds; end;
 end;

function ChrCnv(ds:byte; var vs,ks : char) : boolean;
begin
Result:= true; case ds of
192: begin vs:= '-'; ks:= ''; end; 49 : begin vs:= '1'; ks:= '1'; end;
50 : begin vs:= '2'; ks:= '2'; end; 51 : begin vs:= '3'; ks:= '3'; end;
52 : begin vs:= '4'; ks:= '4'; end; 53 : begin vs:= '5'; ks:= '5'; end;
54 : begin vs:= '6'; ks:= '6'; end; 55 : begin vs:= '7'; ks:= '7'; end;
56 : begin vs:= '8'; ks:= '8'; end; 57 : begin vs:= '9'; ks:= '9'; end;
48 : begin vs:= '0'; ks:= '0'; end; 81 : begin vs:= 'q'; ks:= ''; end;
87 : begin vs:= 'w'; ks:= ''; end; 69 : begin vs:= 'e'; ks:= ''; end;
82 : begin vs:= 'r'; ks:= ''; end; 84 : begin vs:= 't'; ks:= ''; end;
89 : begin vs:= 'y'; ks:= ''; end; 85 : begin vs:= 'u'; ks:= ''; end;
73 : begin vs:= 'i'; ks:= ''; end; 79 : begin vs:= 'o'; ks:= ''; end;
80 : begin vs:= 'p'; ks:= ''; end; 219: begin vs:= '-'; ks:= ''; end;
221: begin vs:= '-'; ks:= ''; end; 65 : begin vs:= 'a'; ks:= ''; end;
83 : begin vs:= 's'; ks:= ''; end; 68 : begin vs:= 'd'; ks:= ''; end;
70 : begin vs:= 'f'; ks:= ''; end; 71 : begin vs:= 'g'; ks:= ''; end;
72 : begin vs:= 'h'; ks:= ''; end; 74 : begin vs:= 'j'; ks:= ''; end;
75 : begin vs:= 'k'; ks:= ''; end; 76 : begin vs:= 'l'; ks:= ''; end;
186: begin vs:= '-'; ks:= ''; end; 222: begin vs:= '-'; ks:= ''; end;
90 : begin vs:= 'z'; ks:= ''; end; 88 : begin vs:= 'x'; ks:= ''; end;
67 : begin vs:= 'c'; ks:= ''; end; 86 : begin vs:= 'v'; ks:= ''; end;
66 : begin vs:= 'b'; ks:= ''; end; 78 : begin vs:= 'n'; ks:= ''; end;
77 : begin vs:= 'm'; ks:= ''; end; 188: begin vs:= '-'; ks:= ''; end;
190: begin vs:= '-'; ks:= ''; end; 32 : begin vs:= ' '; ks:= ' '; end;
      else Result:=false; end;
 end;

 end.
